#define SNESLO 1
#define SNESHI 2

/*
game shark
playstation
dreamcast
n64	12
gb  	8
sat	12

The Game Genie was a very
   successful piece of equipment made for the Nintendo 8-bit, Super
      Nintendo, Sega Genesis, Sega GameGear and Nintendo Gameboy. A game

TODO:  -par	apply Pro Action Replay code; $FILE=CODE\n\


*/
int proactionreplay(char *name,int console,char *code,long start)
{
    unsigned long address=0;
    unsigned char byte=0;
    unsigned long data = 0;
    if (strlen (code) != 8 ||
        sscanf (code, "%lx", &data) != 1)
//	return ("Invalid Pro Action Replay code - should be 8 hex digits in length.");
return(-1);
    address = data >> 8;
    byte = data&0xff;
//		printf("rom addr %x value %x\n",address,byte);
    return (0);
}

/*int goldfinger(char *name,int console,char *code,long start)
//(const char *code, uint32 &address, bool8 &sram,
//			        uint8 &num_bytes, uint8 bytes[3])
{
    char tmp [15];
    if (strlen (code) != 14)
	return ("Invalid Gold Finger code should be 14 hex digits in length.");

    strncpy (tmp, code, 5);
    tmp [5] = 0;
    if (sscanf (tmp, "%x", &address) != 1)
//	return ("Invalid Gold Finger code.");
return(-1);
    int i;
    for (i = 0; i < 3; i++)
    {
	strncpy (tmp, code + 5 + i * 2, 2);
	tmp [2] = 0;
	int byte;
	if (sscanf (tmp, "%x", &byte) != 1)
	    break;
	bytes [i] = (uint8) byte;
    }
    num_bytes = i;
    sram = code [13] == '1';
    return (0);
}
*/
int gamegenie(char *name,int console,char *code,long start)
{
    unsigned long address=0;
    unsigned long data = 0;
    unsigned char byte=0;
    char new_code [12];
    	static char *real_hex  = "0123456789ABCDEF";
    	static char *genie_hex = "DF4709156BC8A23E";
//static char *other_genie_hex = "6BC8A23EDF470915";
FILE *fh;
/*
                                 D <-> 6     0 <-> A
                                 F <-> B     9 <-> 2
                                 4 <-> C     1 <-> 3
                                 7 <-> 8     5 <-> E
  */                               


int i,j;    
    if (strlen (code) != 9 || *(code + 4) != '-' )
//	return ("Invalid Game Genie(tm) code - should be 'xxxx-xxxx'.");
return(-1);

    strcpy (new_code, "0x");
    strncpy (new_code + 2, code, 4);
    strcpy (new_code + 6, code + 5);

    
    for (i = 2; i < 10; i++)
    {
	if (islower (new_code [i]))
	    new_code [i] = toupper (new_code [i]);
	for (j = 0; j < 16; j++)
	{
	    if (new_code [i] == genie_hex [j])
	    {
		new_code [i] = real_hex [j];
		break;
	    }
	}
	if (j == 16)
//	    return ("Invalid hex-character in Game Genie(tm) code");
return(-1);
    }
    sscanf (new_code, "%lx", &data);
    byte = (data >> 24)&0xff;
    address = data & 0xffffff;
    address = ((address & 0x003c00) << 10) +
	      ((address & 0x00003c) << 14) +
	      ((address & 0xf00000) >>  8) +
	      ((address & 0x000003) << 10) +
	      ((address & 0x00c000) >>  6) +
	      ((address & 0x0f0000) >> 12) +
	      ((address & 0x0003c0) >>  6);

if(console==SNESLO||console==SNESHI)
{
/*
printf("Galoob made 3 different versions of the SNES Game Genie during its lifetime. 
However, there is a slight difference in how each of them interpret a code.
Therefore certain codes may not work on your Game Genie because the coders
had a different version. Use this conversion chart to change slot 3 of the
code and it should now work:
                                 D <-> 6     0 <-> A
                                 F <-> B     9 <-> 2
                                 4 <-> C     1 <-> 3
                                 7 <-> 8     5 <-> E
                                 
                                 Ex:
                                 Old Code = BC38-8F06
                                 New Code = BC18-8F06
");
*/

	address=(((address&0xff0000)>>1)+(address&0x007fff))&0x0fffff;
	if(console==SNESLO)address=address+0x200;
	else address=address+0x268200;                
}




fhexdump(name,address+start,1);

if(!(fh=fopen(name,"r+b")))return(-1);
fseek(fh,address+start,SEEK_SET);
fputc(byte,fh);
fclose(fh);        

fhexdump(name,address+start,1);
printf("\n");
    return (0);
}
