#define SEGASTART 0
int genromheader(char *romheader,char *name,long hsize,char *mode)
{
register int x;
char oddchar[128];
char evenchar[128];
FILE *fh;

	if(mode[0]=='w')
	{
		for(x=0;x<sizeof(evenchar);x++)
		evenchar[x]=romheader[x*2];
		for(x=0;x<sizeof(oddchar);x++)
		oddchar[x]=romheader[(x*2)+1];
		
	        if(!(fh=fopen(name,"r+b")))return(-1);
        
		fseek(fh,128+hsize,SEEK_SET);
		fwrite(oddchar,sizeof(oddchar),1,fh);
		fseek(fh,0,SEEK_END);
		fseek(fh,((!hsize)?(ftell(fh)/2):8192)+128+hsize,SEEK_SET);
		fwrite(evenchar,sizeof(evenchar),1,fh);

	}
	else
	{
//memset(oddchar,0,128);
//memset(evenchar,0,128);
//memset(romheader,0,256);

	        if(!(fh=fopen(name,"rb")))return(-1);
        
		fseek(fh,128+hsize,SEEK_SET);
		fread(oddchar,sizeof(oddchar),1,fh);
		fseek(fh,0,SEEK_END);
		fseek(fh,((!hsize)?(ftell(fh)/2):8192)+128+hsize,SEEK_SET);
		fread(evenchar,sizeof(evenchar),1,fh);

		for(x=0;x<(sizeof(evenchar)+sizeof(oddchar));x++)
		romheader[x]=(!(x%2))?evenchar[x/2]:oddchar[(x-1)/2];
	}
	return(0);
}

int genchksum(char *romheader,char *name,long hsize)
{
/*FILE *fh;
long i;
long calcromsize = 0;
unsigned short cartchecksum = 0, calcchecksum = 0;
unsigned char cartcompchecksum = 0, calccompchecksum = 0;
int ch;*/
                                                
genromheader(romheader,name,hsize,"rb");
fhexdump(romheader,0x8e,2);
/*
if(!(fh=fopen(name,"r+b")))return(-1);

while (fsize(name,hsize) > (0x8000L << calcromsize))calcromsize += 1;
 fseek(fh, 0+hsize, SEEK_SET);
                        
for (i = 0; i < (0x8000L << calcromsize); i += 1) 
{
	ch = fgetc(fh);
	if (ch == EOF)ch = 0;

	if (i < 0x0134L)calcchecksum += ch;
	else if (i < 0x014DL) 
	{
		calccompchecksum += ch;
		calcchecksum += ch;
	} 
	else if (i == 0x014DL)cartcompchecksum = ch;
	else if (i == 0x014EL)cartchecksum = ch << 8;
	else if (i == 0x014FL)cartchecksum |= ch;
	else calcchecksum += ch;
}

calccompchecksum = 0xE7 - calccompchecksum;
calcchecksum += calccompchecksum;

if (cartchecksum != calcchecksum) 
{
	fflush(fh);
	fseek(fh, 0x014EL+hsize, SEEK_SET);
		fputc(calcchecksum >> 8, fh);
		fputc(calcchecksum & 0xFF, fh);
	fflush(fh);
} 
//else printf("\tChecksum is OK\n");


if (cartcompchecksum != calccompchecksum) 
{
	fflush(fh);
	fseek(fh, 0x014DL+hsize, SEEK_SET);
	fputc(calccompchecksum, fh);
	fflush(fh);
}
//else printf("\tCompChecksum is OK\n");

fclose(fh);

fhexdump(name,GBSTART+hsize+0x4d,3);
printf("\n");
	return(0);

*/








fhexdump(romheader,0x8e,2);
printf("\n");

//	genromheader(romheader,name,hsize,"wb");
	return(0);

/*

// Dave: This is my code, but I thought it belonged here
// Joe: Thanks Dave! No problem ;)
static unsigned short calculate_checksum(unsigned char *rom,int len)
{
  unsigned short checksum=0;
  int i;
  for (i=512;i<=(len-2);i+=2)
  {
    checksum+=(rom[i+1]<<8);
    checksum+=rom[i+0];
  }
rom[0x18f]=cs>>8; 
rom[0x18e]=cs&255;
}

*/
}

int swap8192gen(char *name,long hsize)
{
register unsigned long x;
size_t size;
char buf[4096],buf2[8192];
FILE *fh,*fh2;

strcpy(buf,name);
buf[strcspn(buf,".")+1]=0;
strcat(buf,isstrlwr(buf)?"tmp":"TMP");
if(!(fh=fopen(name,"rb")))return(-1);
remove(buf);
if(!(fh2=fopen(buf,"ab")))
{
	fclose(fh);
	return(-1);
}
fread(buf2,hsize,1,fh);
fwrite(buf2,hsize,1,fh2);

fseek(fh,0,SEEK_END);
size=(size_t)ftell(fh)-hsize;
fseek(fh,hsize,SEEK_SET);
if(hsize!=0)
{
	for(x=0;x<(size/sizeof(buf2))/2;x++)
	{
		fseek(fh,hsize+(x*sizeof(buf2)),SEEK_SET);
		fread(buf2,sizeof(buf2),1,fh);
		fwrite(buf2,sizeof(buf2),1,fh2);

		fseek(fh,hsize+(size/2)+(x*sizeof(buf2)),SEEK_SET);
		fread(buf2,sizeof(buf2),1,fh);
		fwrite(buf2,sizeof(buf2),1,fh2);
	}
}
else
{
	for(x=0;x<(size/sizeof(buf2))/2;x++)
	{
		fseek(fh,hsize+(x*(sizeof(buf2)*2)),SEEK_SET);
		fread(buf2,sizeof(buf2),1,fh);
		fwrite(buf2,sizeof(buf2),1,fh2);
	}
	for(x=0;x<(size/sizeof(buf2))/2;x++)
	{
		fseek(fh,hsize+(x*(sizeof(buf2)*2))+sizeof(buf2),SEEK_SET);
		fread(buf2,sizeof(buf2),1,fh);
		fwrite(buf2,sizeof(buf2),1,fh2);
	}
}

if((size%sizeof(buf2))!=0)
{
	fseek(fh,size-(size%sizeof(buf2))+hsize,SEEK_SET);
	fread(buf2,size%sizeof(buf2),1,fh);
	fwrite(buf2,size%sizeof(buf2),1,fh2);
}
fclose(fh);
fclose(fh2);
remove(name);
rename(buf,name); 
return(0);
}

char *joingenesis(char *name,long hsize)
{
register unsigned long x;
size_t size;
char buf[4096],buf2[4096],buf3[32758];
FILE *fh,*fh2;

//copiers for sega mega drive use the most complicated file formats

strcpy(buf,name);
strcpy(buf2,name);
buf2[strcspn(buf2,".")+1]=0;
strcat(buf2,isstrlwr(buf2)?"tmp":"TMP");

strcpy(buf,name);
if(!hsize)buf[strcspn(buf,".")-1]++;
else buf[strcspn(buf,".")+1]++;

if(access(buf,F_OK)!=0)
{
	return(name);
}

strcpy(buf,name);

if(!hsize)
{
// file1 file2 file3 file4
//  1/2   3/4   5/6   7/8 (1st half/2nd half)
// joinedfile
//  1/3/5/7/2/4/6/8
	if(!(fh=fopen(buf2,"wb")))return("-1");

	for(;;)
	{
		if(!(fh2=fopen(buf,"rb")))break;

		fseek(fh2,0,SEEK_END);
		size=(size_t)(ftell(fh2)/2)-hsize;
		fseek(fh2,hsize,SEEK_SET);

		for(x=0;x<size/sizeof(buf3);x++)
		{
			fread(buf3,sizeof(buf3),1,fh2);
			fwrite(buf3,sizeof(buf3),1,fh);
		}

		if((size%sizeof(buf3))!=0)
		{
			fread(buf3,size%sizeof(buf3),1,fh2);
			fwrite(buf3,size%sizeof(buf3),1,fh);
		}
		fclose(fh2);
		                        
		buf[strcspn(buf,".")-1]++;
	}

	strcpy(buf,name);
	for(;;)
	{
		if(!(fh2=fopen(buf,"rb")))break;

		fseek(fh2,0,SEEK_END);
		size=(size_t)(ftell(fh2)/2)-hsize;
		fseek(fh2,size+hsize,SEEK_SET);

		for(x=0;x<size/sizeof(buf3);x++)
		{
			fread(buf3,sizeof(buf3),1,fh2);
			fwrite(buf3,sizeof(buf3),1,fh);
		}

		if((size%sizeof(buf3))!=0)
		{
			fread(buf3,size%sizeof(buf3),1,fh2);
			fwrite(buf3,size%sizeof(buf3),1,fh);
		}
		fclose(fh2);
		                        
		buf[strcspn(buf,".")-1]++;
	}
	fclose(fh);
}
else 
{
	fcopy(buf,0,buf2,"wb");
	for(;;)
	{
		buf[strcspn(buf,".")+1]++;
		if(fcopy(buf,hsize,buf2,"ab")==-1)break;
	}
}
strcpy(name,buf2);
return(name);
}
#define MBIT 131072


//options

#define NFO	11//show rom info
#define SPLIT	1//split
#define SMD	2//convert to super magic drive
#define PAD	6//fix size
#define MGH	7//convert to Multi Game Hunter (binary)
#define NAME	55//change name
#define NAME2	56//change jap name
#define SEGA1991 57//fix third party roms
#define JOIN	20
#define CHK     5//fix checksum

//this single routine does all the sega mega drive stuff

int segamegadrive(char *name,int option,char *option2)
{
//option[0] = header: '1'=yes, ' '=no, '?'=unknown
//&option[16] = string

#define SEGAHEADER0 512

char mgh[512];
char mghcharset[1024]={
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		 /* ! */ 0x18, 0x18, 0x18, 0x18, 0x18, 0x00, 0x18, 0x00,
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		 /* & */ 0x3c, 0x66, 0x18, 0x3c, 0x66, 0x66, 0x3c, 0x02,
		 /* ' */ 0x18, 0x18, 0x18, 0x18, 0x00, 0x00, 0x00, 0x00,
		 /* ( */ 0x0c, 0x18, 0x18, 0x18, 0x18, 0x18, 0x0c, 0x00,
		 /* ) */ 0x30, 0x18, 0x18, 0x18, 0x18, 0x18, 0x30, 0x00,
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		 /* , */ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x08,
		 /* - */ 0x00, 0x00, 0x00, 0x7e, 0x00, 0x00, 0x00, 0x00,
		 /* . */ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x00,
		 /* / */ 0x06, 0x06, 0x0c, 0x18, 0x30, 0x60, 0x60, 0x00,
		 /* 0 */ 0x3c, 0x66, 0x66, 0x66, 0x66, 0x66, 0x3c, 0x00,
		 /* 1 */ 0x38, 0x18, 0x18, 0x18, 0x18, 0x18, 0x3c, 0x00,
		 /* 2 */ 0x3c, 0x66, 0x06, 0x06, 0x7c, 0x60, 0x7e, 0x00,
		 /* 3 */ 0x3c, 0x66, 0x06, 0x1c, 0x06, 0x66, 0x3c, 0x00,
		 /* 4 */ 0x18, 0x38, 0x58, 0x7c, 0x18, 0x18, 0x3c, 0x00,
		 /* 5 */ 0x7e, 0x60, 0x7c, 0x06, 0x06, 0x66, 0x3c, 0x00,
		 /* 6 */ 0x3c, 0x66, 0x60, 0x7c, 0x66, 0x66, 0x3c, 0x00,
		 /* 7 */ 0x7e, 0x06, 0x0c, 0x0c, 0x18, 0x18, 0x18, 0x00,
		 /* 8 */ 0x3c, 0x66, 0x66, 0x3c, 0x66, 0x66, 0x3c, 0x00,
		 /* 9 */ 0x3c, 0x66, 0x66, 0x3e, 0x06, 0x66, 0x3c, 0x00,
		 /* : */ 0x00, 0x00, 0x18, 0x00, 0x18, 0x00, 0x00, 0x00,
		 /* ; */ 0x00, 0x00, 0x18, 0x00, 0x18, 0x08, 0x00, 0x00,
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		 /* = */ 0x00, 0x00, 0x7e, 0x00, 0x7e, 0x00, 0x00, 0x00,
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		 /* A */ 0x18, 0x3c, 0x66, 0x66, 0x7e, 0x66, 0x66, 0x00,
		 /* B */ 0x7c, 0x66, 0x66, 0x7c, 0x66, 0x66, 0x7c, 0x00,
		 /* C */ 0x3c, 0x66, 0x60, 0x60, 0x60, 0x66, 0x3c, 0x00,
		 /* D */ 0x7c, 0x66, 0x66, 0x66, 0x66, 0x66, 0x7c, 0x00,
		 /* E */ 0x7e, 0x60, 0x60, 0x7e, 0x60, 0x60, 0x7e, 0x00,
		 /* F */ 0x7e, 0x60, 0x60, 0x7e, 0x60, 0x60, 0x60, 0x00,
		 /* G */ 0x3e, 0x60, 0x60, 0x6e, 0x66, 0x66, 0x3e, 0x00,
		 /* H */ 0x66, 0x66, 0x66, 0x7e, 0x66, 0x66, 0x66, 0x00,
		 /* I */ 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x00,
		 /* J */ 0x06, 0x06, 0x06, 0x06, 0x66, 0x66, 0x3c, 0x00,
		 /* K */ 0x66, 0x6c, 0x78, 0x70, 0x78, 0x6c, 0x66, 0x00,
		 /* L */ 0x60, 0x60, 0x60, 0x60, 0x60, 0x60, 0x7e, 0x00,
		 /* M */ 0xc6, 0xee, 0xfe, 0xd6, 0xc6, 0xc6, 0xc6, 0x00,
		 /* N */ 0x66, 0x76, 0x7e, 0x7e, 0x6e, 0x66, 0x66, 0x00,
		 /* O */ 0x3c, 0x66, 0x66, 0x66, 0x66, 0x66, 0x3c, 0x00,
		 /* P */ 0x7c, 0x66, 0x66, 0x7c, 0x60, 0x60, 0x60, 0x00,
		 /* Q */ 0x3c, 0x66, 0x66, 0x66, 0x66, 0x6e, 0x3e, 0x00,
		 /* R */ 0x7c, 0x66, 0x66, 0x7c, 0x6c, 0x66, 0x66, 0x00,
		 /* S */ 0x3c, 0x66, 0x60, 0x3c, 0x06, 0x66, 0x3c, 0x00,
		 /* T */ 0x7e, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x00,
		 /* U */ 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x3e, 0x00,
		 /* V */ 0x66, 0x66, 0x66, 0x66, 0x66, 0x3c, 0x3c, 0x00,
		 /* W */ 0x56, 0x56, 0x56, 0x56, 0x56, 0x56, 0x2c, 0x00,
		 /* X */ 0x66, 0x66, 0x3c, 0x10, 0x3c, 0x66, 0x66, 0x00,
		 /* Y */ 0x66, 0x66, 0x66, 0x3c, 0x18, 0x18, 0x18, 0x00,
		 /* Z */ 0x7e, 0x06, 0x0c, 0x18, 0x30, 0x60, 0x7e, 0x00,
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		 /* _ */ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7e,
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		 /* a */ 0x00, 0x00, 0x3c, 0x06, 0x3e, 0x66, 0x3e, 0x00,
		 /* b */ 0x60, 0x60, 0x7c, 0x66, 0x66, 0x66, 0x7c, 0x00,
		 /* c */ 0x00, 0x00, 0x3c, 0x66, 0x60, 0x66, 0x3c, 0x00,
		 /* d */ 0x06, 0x06, 0x6e, 0x66, 0x66, 0x66, 0x3e, 0x00,
		 /* e */ 0x00, 0x00, 0x3c, 0x66, 0x7e, 0x60, 0x3c, 0x00,
		 /* f */ 0x0c, 0x18, 0x18, 0x3c, 0x18, 0x18, 0x3c, 0x00,
		 /* g */ 0x00, 0x00, 0x3c, 0x66, 0x66, 0x3e, 0x06, 0x7c,
		 /* h */ 0x60, 0x60, 0x7c, 0x66, 0x66, 0x66, 0x66, 0x00,
		 /* i */ 0x18, 0x00, 0x18, 0x18, 0x18, 0x18, 0x3c, 0x00,
		 /* j */ 0x00, 0x0c, 0x00, 0x0c, 0x0c, 0x0c, 0x6c, 0x38,
		 /* k */ 0x60, 0x60, 0x66, 0x6c, 0x78, 0x6c, 0x66, 0x00,
		 /* l */ 0x38, 0x18, 0x18, 0x18, 0x18, 0x18, 0x3c, 0x00,
		 /* m */ 0x00, 0x00, 0x5c, 0x76, 0x56, 0x56, 0x56, 0x00,
		 /* n */ 0x00, 0x00, 0x6c, 0x7e, 0x66, 0x66, 0x66, 0x00,
		 /* o */ 0x00, 0x00, 0x3c, 0x66, 0x66, 0x66, 0x3c, 0x00,
		 /* p */ 0x00, 0x00, 0x7c, 0x66, 0x66, 0x7c, 0x60, 0x60,
		 /* q */ 0x00, 0x00, 0x3e, 0x66, 0x66, 0x3e, 0x06, 0x06,
		 /* r */ 0x00, 0x00, 0x18, 0x1a, 0x18, 0x18, 0x3c, 0x00,
		 /* s */ 0x00, 0x00, 0x3e, 0x60, 0x3c, 0x06, 0x7c, 0x00,
		 /* t */ 0x00, 0x18, 0x3c, 0x18, 0x18, 0x18, 0x3c, 0x00,
		 /* u */ 0x00, 0x00, 0x66, 0x66, 0x66, 0x66, 0x3a, 0x00,
		 /* v */ 0x00, 0x00, 0x66, 0x66, 0x3c, 0x3c, 0x18, 0x00,
		 /* w */ 0x00, 0x00, 0x56, 0x56, 0x56, 0x56, 0x7e, 0x00,
		 /* x */ 0x00, 0x00, 0x66, 0x66, 0x18, 0x66, 0x66, 0x00,
		 /* y */ 0x00, 0x00, 0x66, 0x66, 0x66, 0x3e, 0x06, 0x7c,
		 /* z */ 0x00, 0x00, 0x7e, 0x0c, 0x18, 0x30, 0x7e, 0x00,
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		 /* | */ 0x18, 0x18, 0x18, 0x00, 0x18, 0x18, 0x18, 0x00,
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
			 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
			 };
char *segaio[]={\
"0",\
"1",\
"2",\
"3",\
"4",\
"5",\
"6",\
"7",\
"8",\
"9",\
"10",\
"11",\
"12",\
"13",\
"14",\
"15",\
"16",\
"17",\
"18",\
"19",\
"20",\
"21",\
"22",\
"23",\
"24",\
"25",\
"26",\
"27",\
"28",\
"29",\
"30",\
"31",\
"",\
"33",\
"34",\
"35",\
"36",\
"37",\
"38",\
"39",\
"40",\
"41",\
"42",\
"43",\
"44",\
"45",\
"46",\
"47",\
"48",\
"49",\
"50",\
"51",\
"Team Player",\
"53",\
"6 Button Pad",\
"55",\
"56",\
"57",\
"58",\
"59",\
"60",\
"61",\
"62",\
"63",\
"64",\
"65",\
"66",\
"67",\
"68",\
"69",\
"70",\
"71",\
"72",\
"73",\
"3 Button Pad",\
"75",\
"Activator",\
"Mega Mouse",\
"78",\
"79",\
"80",\
"81",\
"82",\
"83",\
"84",\
"85",\
"86",\
"87",\
"88",\
"89",\
"90",\
"91",\
"92",\
"93",\
"94",\
"95",\
"96",\
"97",\
"98",\
"99",\
"100",\
"101",\
"102",\
"103",\
"104",\
"105",\
"106",\
"107",\
"108",\
"109",\
"110",\
"111",\
"112",\
"113",\
"114",\
"115",\
"116",\
"117",\
"118",\
"119",\
"120",\
"121",\
"122",\
"123",\
"124",\
"125",\
"126",\
"127",\
"128",\
"129",\
"130",\
"131",\
"132",\
"133",\
"134",\
"135",\
"136",\
"137",\
"138",\
"139",\
"140",\
"141",\
"142",\
"143",\
"144",\
"145",\
"146",\
"147",\
"148",\
"149",\
"150",\
"151",\
"152",\
"153",\
"154",\
"155",\
"156",\
"157",\
"158",\
"159",\
"160",\
"161",\
"162",\
"163",\
"164",\
"165",\
"166",\
"167",\
"168",\
"169",\
"170",\
"171",\
"172",\
"173",\
"174",\
"175",\
"176",\
"177",\
"178",\
"179",\
"180",\
"181",\
"182",\
"183",\
"184",\
"185",\
"186",\
"187",\
"188",\
"189",\
"190",\
"191",\
"192",\
"193",\
"194",\
"195",\
"196",\
"197",\
"198",\
"199",\
"200",\
"201",\
"202",\
"203",\
"204",\
"205",\
"206",\
"207",\
"208",\
"209",\
"210",\
"211",\
"212",\
"213",\
"214",\
"215",\
"216",\
"217",\
"218",\
"219",\
"220",\
"221",\
"222",\
"223",\
"224",\
"225",\
"226",\
"227",\
"228",\
"229",\
"230",\
"231",\
"232",\
"233",\
"234",\
"235",\
"236",\
"237",\
"238",\
"239",\
"240",\
"241",\
"242",\
"243",\
"244",\
"245",\
"246",\
"247",\
"248",\
"249",\
"250",\
"251",\
"252",\
"253",\
"254",\
"255"\
};
char *maker[]={"0",\
"Accolade",\
"Virgin Games",\
"Parker Brothers",\
"Westone",\
"5",\
"6",\
"7",\
"8",\
"9",\
"Takara",\
"Taito",\
"Capcom",\
"Data East",\
"Namco",\
"Sunsoft",\
"16",\
"17",\
"18",\
"19",\
"20",\
"21",\
"Extreme",\
"Vic Tokai",\
"24",\
"25",\
"26",\
"27",\
"28",\
"29",\
"30",\
"31",\
"32",\
"Kaneko",\
"34",\
"35",\
"Tecmo",\
"37",\
"38",\
"39",\
"40",\
"41",\
"42",\
"43",\
"44",\
"Game Arts",\
"46",\
"47",\
"Tengen",\
"49",\
"Electronic Arts",\
"51",\
"52",\
"53",\
"54",\
"Psygnosis",\
"56",\
"57",\
"58",\
"59",\
"JVC",\
"61",\
"62",\
"63",\
"64",\
"65",\
"66",\
"67",\
"CRI",\
"69",\
"Virgin Games",\
"71",\
"72",\
"73",\
"74",\
"75",\
"KOEI",\
"77",\
"78",\
"U.S. Gold",\
"80",\
"Acclaim",\
"82",\
"Gametek",\
"84",\
"85",\
"Absolute",\
"Mindscape",\
"Domark",\
"89",\
"90",\
"91",\
"92",\
"Sony Imagesoft",\
"Sony Imagesoft",\
"Konami",\
"96",\
"Tradewest",\
"98",\
"Codemasters",\
"T*HQ",\
"TecMagik",\
"102",\
"Takara",\
"104",\
"105",\
"106",\
"107",\
"108",\
"109",\
"110",\
"111",\
"Hi Tech Entertainment",\
"Psygnosis",\
"114",\
"115",\
"116",\
"117",\
"118",\
"Accolade",\
"120",\
"121",\
"122",\
"123",\
"Spectrum HoloByte",\
"Interplay"\
};
char *country[]={\
"0",\
"1",\
"2",\
"3",\
"4",\
"5",\
"6",\
"7",\
"8",\
"9",\
"10",\
"11",\
"12",\
"13",\
"14",\
"15",\
"16",\
"17",\
"18",\
"19",\
"20",\
"21",\
"22",\
"23",\
"24",\
"25",\
"26",\
"27",\
"28",\
"29",\
"30",\
"31",\
"",\
"33",\
"34",\
"35",\
"36",\
"37",\
"38",\
"39",\
"40",\
"41",\
"42",\
"43",\
"44",\
"45",\
"46",\
"47",\
"48",\
"49",\
"50",\
"51",\
"52",\
"53",\
"54",\
"55",\
"56",\
"57",\
"58",\
"59",\
"60",\
"61",\
"62",\
"63",\
"64",\
"Asia",\
"Brazil",\
"67",\
"68",\
"Europe",\
"70",\
"71",\
"72",\
"73",\
"Japan",\
"75",\
"76",\
"77",\
"78",\
"79",\
"80",\
"81",\
"82",\
"83",\
"84",\
"U.S.A.",\
"86",\
"87",\
"88",\
"89",\
"90",\
"91",\
"92",\
"93",\
"94",\
"95",\
"96",\
"97",\
"98",\
"99",\
"100",\
"101",\
"102",\
"103",\
"104",\
"105",\
"106",\
"107",\
"108",\
"109",\
"110",\
"111",\
"112",\
"113",\
"114",\
"115",\
"116",\
"117",\
"118",\
"119",\
"120",\
"121",\
"122",\
"123",\
"124",\
"125",\
"126",\
"127",\
"128",\
"129",\
"130",\
"131",\
"132",\
"133",\
"134",\
"135",\
"136",\
"137",\
"138",\
"139",\
"140",\
"141",\
"142",\
"143",\
"144",\
"145",\
"146",\
"147",\
"148",\
"149",\
"150",\
"151",\
"152",\
"153",\
"154",\
"155",\
"156",\
"157",\
"158",\
"159",\
"160",\
"161",\
"162",\
"163",\
"164",\
"165",\
"166",\
"167",\
"168",\
"169",\
"170",\
"171",\
"172",\
"173",\
"174",\
"175",\
"176",\
"177",\
"178",\
"179",\
"180",\
"181",\
"182",\
"183",\
"184",\
"185",\
"186",\
"187",\
"188",\
"189",\
"190",\
"191",\
"192",\
"193",\
"194",\
"195",\
"196",\
"197",\
"198",\
"199",\
"200",\
"201",\
"202",\
"203",\
"204",\
"205",\
"206",\
"207",\
"208",\
"209",\
"210",\
"211",\
"212",\
"213",\
"214",\
"215",\
"216",\
"217",\
"218",\
"219",\
"220",\
"221",\
"222",\
"223",\
"224",\
"225",\
"226",\
"227",\
"228",\
"229",\
"230",\
"231",\
"232",\
"233",\
"234",\
"235",\
"236",\
"237",\
"238",\
"239",\
"240",\
"241",\
"242",\
"243",\
"244",\
"245",\
"246",\
"247",\
"248",\
"249",\
"250",\
"251",\
"252",\
"253",\
"254",\
"Unknown Country"\
};
char *copier[]={"Multi Game*/MGD2/MGH/RAW","Super Magicom Drive/SMD"};
register long x,y;
char *romname;
char romheader[256];
char buf[32768],buf2[4096];
unsigned long hsize;
//char oddchar[128];
//char evenchar[128];
char header[512];
FILE *fh;
        
if(option==NFO&&fcdromdump(name,"Genesis/Sega Mega Drive/Sega CD/32X/Nomad")!=-1)return(0);

romname=name;

//first indentify the rom as a sega mega drive/genesis rom and test for
//header

hsize=0;
if(fgetc2(romname,128+hsize)=='E'&&fgetc2(romname,128+hsize+1)=='A')hsize=0;
else
{
	hsize=SEGAHEADER0;
	if(fgetc2(romname,128+hsize)=='E'&&fgetc2(romname,128+hsize+1)=='A')hsize=SEGAHEADER0;
	else {if(!option)return(-1);}
}
if(fsize(romname,hsize)<32768){if(!option)return(-1);}

if(option2[0]!='?')hsize=((option2[0]=='0')?0:SEGAHEADER0);

if(!(romname=strrchr(name,'/')))romname=name;
else romname++;
//strcpy(romname,name);
strcpy(buf,name);
buf[strlen(buf)-strlen(romname)]=0;
chdir(buf);

switch(option)
{
case SPLIT:
	if(!hsize)
	{
		strcpy(romname,joingenesis(romname,hsize));
	
		strcpy(buf,isstrlwr(romname)?"md":"MD");
		strcpy(buf2,romname);
		buf2[strcspn(buf2,".")]=0;
		strcat(buf2,"________");
		strcat(buf,buf2);
		buf[7]=isstrlwr(buf)?'a':'A';
		buf[8]=0;
		sprintf(buf2,"%s.%03lu",buf,(unsigned long)fsize(romname,hsize)/MBIT);

		for(x=0;x<(fsize(romname,hsize)/(4*MBIT));x++)
		{
			fcopy3(romname,x*4*MBIT,4*MBIT,buf2,"wb");
			buf2[strcspn(buf2,".")-1]++;
		}                
		if((fsize(romname,hsize)%(4*MBIT))!=0)
		fcopy3(romname,(x+1)*4*MBIT,(fsize(romname,hsize)%(4*MBIT)),buf2,"wb");

		remove(romname);
	}
	else
	{

//smd hat ein merkwrdiges 8192 bloecke format wo die erste und zweite
//hlfte vermischt werden
/*
		memset(header,0,sizeof(header));
		fstrncpy(header,romname,0,sizeof(header));

		strcpy(buf,romname);
		buf[strcspn(buf,".")+1]=0;
		strcat(buf,isstrlwr(buf)?"tmp":"TMP");
		fcopy3(romname,hsize,fsize(romname,hsize),buf,"wb");

		strcpy(buf2,romname);
		buf2[strcspn(buf2,".")+1]=0;
		strcat(buf2,"1");

		for(x=0;x<fsize(romname,hsize)/(4*MBIT);x++)
		{
			header[1]=(((4*MBIT)/8192)/256);
			header[0]=(((4*MBIT)/8192)-(header[1]*256));
			
		        if(!(fh=fopen(buf2,"wb")))return(-1);
			fwrite(header,sizeof(header),1,fh);
		        fclose(fh);
			        
			fcopy3(buf,x*4*MBIT,4*MBIT,buf2,"ab");
			
			buf2[strcspn(buf2,".")+1]++;
		}
		if((fsize(romname,hsize)%(4*MBIT))!=0)
		{
			header[1]=(((fsize(buf,0)%(4*MBIT))/8192)/256);
			header[0]=(((fsize(buf,0)%(4*MBIT))/8192)-(header[1]*256));
			
		        if(!(fh=fopen(buf2,"wb")))return(-1);
			fwrite(header,sizeof(header),1,fh);
		        fclose(fh);
		        
			fcopy3(buf,((x+1)*4*MBIT),(fsize(buf,0)%(4*MBIT)),buf2,"ab");
		}
		remove(buf);
*/
	}
break;

case JOIN:
	if(!hsize)segamegadrive(name,MGH,option2);
	else segamegadrive(name,SMD,option2);
break;

case PAD:
	strcpy(buf,romname);
	fpad(joingenesis(buf,hsize),hsize,"wb");
	rename(buf,romname);
break;

case MGH:
	strcpy(buf,isstrlwr(romname)?"md":"MD");
	strcpy(buf2,romname);
	buf2[strcspn(buf2,".")]=0;
	strcat(buf2,"________");
	strcat(buf,buf2);
	buf[7]='_';
	buf[8]=0;
	sprintf(buf2,"%s.%03lu",buf,(unsigned long)fsize(romname,hsize)/MBIT);
	strcpy(buf,romname);

//printf("%s",joingenesis(buf,hsize));
	fcopy(joingenesis(buf,hsize),hsize,buf2,"wb");

//	remove(buf);
	if(hsize!=0)swap8192gen(buf2,0);

//automatically create MGH name file

	memset(mgh,0,sizeof(mgh));
	mgh[0]='M';
	mgh[1]='G';
	mgh[2]='H';
	mgh[3]=0x1a;
	mgh[4]=0x06;
	mgh[5]=0xf0;
	mgh[31]=0xff;

	genromheader(romheader,name,hsize,"rb");
	
	strcpy(buf,&romheader[32]);
	buf[48]=0;

	for(x=0;x<15;x++)
	{
		for(y=0;y<4;y++)mgh[((x+2)*16)+y+4]=mghcharset[(buf[x]*8)+y];
		for(y=4;y<8;y++)mgh[((x+2)*16)+y+244]=mghcharset[(buf[x]*8)+y];
	}

	strcpy(buf,romname);
	buf[strcspn(buf,".")+1]=0;
	strcat(buf,isstrlwr(buf)?"mgh":"MGH");

	if(!(fh=fopen(buf,"wb")))break;
	fwrite(mgh,sizeof(mgh),1,fh);
	fclose(fh);
break;

case SMD:
/*
        Important SMD Header Bytes:

        Offset 00h:     Number of 16KB blocks. This number may be incorrect in
                        some files, it is recommended you calculate it
                        manually: num_blocks = (sizeof(file) - 512) div 16384
        Offset 02h:     Indicates wether ROM is a part of a series of a split
                        ROM (1, or possibly just non-zero,) or wether it is
                        a standalone ROM or the last ROM in a split series (0)
        Offset 08h:     AAh
        Offset 09h:     BBh

        * Note: Some documentation claims that byte 1 is always 3 and all
          other bytes besides those mentioned as important are 0. This is not
          always the case. The header information in this document should be
          considered fairly accurate.
*/


	memset(header,0,sizeof(header));
        header[0]=(fsize(romname,hsize))/16384;
        header[1]=0x03;
//	header[2]=0;
	header[8]=0xaa;
	header[9]=0xbb;
	header[10]=0x06;

	strcpy(buf,romname);
	buf[strcspn(buf,".")+1]=0;
	strcat(buf,isstrlwr(buf)?"smd":"SMD");

	if(!(fh=fopen(buf,"wb")))return(-1);
	fwrite(header,sizeof(header),1,fh);
	fclose(fh);

	strcpy(buf2,romname);
	fcopy(joingenesis(buf2,hsize),hsize,buf,"ab");
	remove(buf2);
	if(!hsize)swap8192gen(buf,SEGAHEADER0);
break;

case NAME:
	strcpy(buf,&option2[16]);
	strcat(buf,"\
                                                                  \
                                                                          ");
//        strcat(option2,"\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0");
	buf[48]=0;
        
	strncpy(&romheader[32],buf,48);

	genromheader(romheader,name,hsize,"wb");


	segamegadrive(name,NFO,option2);
break;

case SEGA1991:
	strcpy(buf,"(C) SEGA\
                                                                  \
                                                                          ");
//        strcat(option2,"\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0");
	buf[48]=0;
        
	strncpy(&romheader[32],buf,48);
	strcpy(buf,"(C)SEGA\
                                                                  \
                                                                          ");
//        strcat(option2,"\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0");
	buf[48]=0;
	strncpy(&romheader[32+48],buf,48);

	genromheader(romheader,name,hsize,"wb");



	segamegadrive(name,NFO,option2);
break;

case CHK:
	genchksum(romheader,name,hsize);
break;

case NAME2:
	strcpy(buf,&option2[16]);
	strcat(buf,"\
                                                                  \
                                                                          ");
//        strcat(option2,"\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0");
	buf[48]=0;
        
	strncpy(&romheader[32+48],buf,48);

	genromheader(romheader,name,hsize,"wb");



	segamegadrive(name,NFO,option2);
break;

case NFO:
	genromheader(romheader,name,hsize,"rb");
	
/*	hexdump(oddchar,0,sizeof(oddchar));
	printf("\n");
	hexdump(evenchar,0,sizeof(evenchar));
	printf("\n");
*/
	fhexdump(romheader,0,sizeof(romheader));
	printf("\n");
	printf("%s\n",(romheader[5]=='G')?"Sega Genesis/Nomad":"Sega Mega Drive/Nomad");
	printf("%s\n",copier[(!hsize)?0:1]);

	strcpy(buf,&romheader[32]);
	buf[48]=0;
	printf("%s\n",buf);
	strcpy(buf,&romheader[80]);
	buf[48]=0;
	printf("%s\n",buf);
	strcpy(buf,&romheader[16]);
	buf[8]=0;
	strcat(buf," ");

	if(!strncmp(buf,"(C)ACLD ",8))strcat(buf,maker[1]);
	if(!strncmp(buf,"(C)VRGN ",8))strcat(buf,maker[2]);
	if(!strncmp(buf,"(C)WADN ",8))strcat(buf,maker[3]);
	if(!strncmp(buf,"(C)WSTN ",8))strcat(buf,maker[4]);
	
	if(buf[3]=='T'&&buf[4]=='-')
	{
	        strcpy(buf2,&buf[5]);
		buf2[strcspn(buf2," ")]=0;
		strcat(buf,maker[atoi(buf2)]);
	}
	printf("%s\n",buf);
	printf("%s %s %s %s %s\n",country[(int)romheader[240]],country[(int)romheader[241]],country[(int)romheader[242]],country[(int)romheader[243]],country[(int)romheader[244]]);

	printf("%ld bytes (%.4f MBit)\n",fsize(romname,hsize),(float)fsize(romname,hsize)/MBIT);


printf("\n");


	if((x=fpad(romname,hsize,"rb"))!=-1)
	{
		if(!x)printf("Padded: No\n");
		else printf("Padded: Maybe, %ld bytes (%.4f MBit)\n",x,(float)x/MBIT);
	}


//	if(((romheader[166]>0)?romheader[166]:romheader[166]+256)==255&&((romheader[167]>0)?romheader[167]:romheader[167]+256)==255)printf("Internal Size: ? MBit\n");
//	else 
printf("Internal Size: %.4f MBit\n",(float)(((romheader[165]>0)?romheader[165]:romheader[165]+256)+1)/2);
        printf("Start: %02x%02x%02x%02x\n", 
                       romheader[0x1a0-256]&0xff, romheader[0x1a1-256]&0xff, romheader[0x1a2-256]&0xff, 
                       romheader[0x1a3-256]&0xff); 
       printf("End: %02x%02x%02x%02x\n", 
                       romheader[0x1a4-256]&0xff, romheader[0x1a5-256]&0xff, romheader[0x1a6-256]&0xff, 
                       romheader[0x1a7-256]&0xff); 
	
//	strcpy(buf,romname);
//	x=fpad(joingenesis(buf,hsize),hsize,"rb");
//	remove(buf);
//	if(!x)printf("Padded: No\n");
//	else printf("Padded: Yes, %ld bytes\n",x);

	if(romheader[128]=='G')printf("RomType: %s\n",(romheader[129]=='M')?"Game":"Application");
	printf("I/O Device(s): %s %s %s %s\n",segaio[(int)romheader[144]],segaio[(int)romheader[145]],segaio[(int)romheader[146]],segaio[(int)romheader[147]]);
	strcpy(buf,&romheader[128]);
	buf[11]=0;
	printf("ProductCode: %s\n",buf);

	strcpy(buf,&romheader[24]);
	buf[8]=0;
	printf("Date: %s\n",buf);







                buf[20]='\0'; 
                strncpy(buf, &romheader[0x1bc-256], 20);                 
                printf("Modem data: %s\n", buf); 
                buf[40]='\0'; 
                strncpy(buf, &romheader[0x1c8-256], 40); 
                printf("Memo: %s\n", buf); 
                buf[3]='\0'; 






	x=(fsize(romname,hsize)-(fsize(romname,hsize)/MBIT)*MBIT);
	printf("CheckSum: %02x%02x\n",((romheader[142]>0)?romheader[142]:romheader[142]+256),((romheader[143]>0)?romheader[143]:romheader[143]+256));
	if(!x)printf("Intro/Trainer: No\n");
	else printf("Intro/Trainer: Yes, %ld bytes\n",x);
	printf("Backup RAM: %s\n",(romheader[176]=='R'&&romheader[177]=='A')?"Yes":"No");
	printf("Version: 1.%c%c\n",romheader[140],romheader[141]);
	printf("\n");
break;

default:
break;
}
return(0);
}






