/*
_ __ ________________________________________________________________ __ _
                                                      ___
    .,,,,     .---._ Oo  .::::. .::::. :::   :::    __\__\
    ( oo)__   (oo) /..\ ::  :: ::  :: :::   :::    \ / Oo\o  (\(\
   /\_  \__) /\_  \/\_,/ ::  .. ::..:: ::'   ::'    _\\`--_/ o/oO \
   \__)_/   _\__)_/_/    :::::: :::::: ::....::.... \_ \  \  \.--'/
   /_/_/    \ /_/_//     `::::' ::  :: `:::::`:::::: /_/__/   /\ \___
 _(__)_)_,   (__)_/  .::::.                      ;::  |_|_    \_/_/\_/\
  o    o      (__)) ,:' `::::::::::::::::::::::::::' (__)_)___(_(_)  
     ________  ________  _____ _____________________/   __/_  __/_________
    _\___   /__\___   /_/____/_\    __________     /    ___/  ______     /
   /    /    /    /    /     /  \      \/    /    /     /     /    /    /
  /    /    /         /     /          /    _____/_    /_    /_   _____/_
 /____/    /_________/     /aBn/fAZ!/nB_________/_____/_____/_________/
- -- /_____\--------/_____/------------------------------------------ -- -
4 Nodes USRobotics & Isdn Power     All Releases Since Day 0 Are Available
 Snes/Sega/GameBoy/GameGear/Ultra 64/PSX/Jaguar/Saturn/Engine/Lynx/NeoGeo
- -- ---------------------------------------------------------------- -- -
*/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <stddef.h>
#include <fcntl.h>
#include <time.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/perm.h>
#include <sys/stat.h>
#include <dirent.h>
#include <ctype.h>
#include <sys/ioctl.h>
#include <errno.h>
#ifdef LINUX
#include <linux/version.h>
#include <linux/iso_fs.h>
#include <linux/cdrom.h>
//#if LINUX_VERSION_CODE < KERNEL_VERSION(2,1,50)
//#include <linux/ucdrom.h>
//#endif
#endif
#ifdef CURSES
#include <curses.h>
#endif

#define BUFSIZE 32768

char *str80(char *opt1)
{
//wordwrap text
/*	register long x,pos;

	for(x=0;x<strlen(opt1);x++)
	{
		if(opt1[x]==32)pos=x;
		if(x==80)opt1[pos]='\n';
	}
	*/
	return(opt1);
	
}

int strwcmp(char *opt1,char *opt2,char wildcard)
{
//str-wildcard-cmp!
	register int x;
	char buf[BUFSIZE],buf2[BUFSIZE];

	if(!wildcard)return(strcmp(opt1,opt2));
	
	x=0;
	strcpy(buf,opt1);
	strcpy(buf2,opt2);
	
	while(buf[x]!=0&&buf2[x]!=0)
	{
		if(buf[x]==wildcard)buf2[x]=wildcard;
		else if(buf2[x]==wildcard)buf[x]=wildcard;
		x++;
	}
	return(strcmp(buf,buf2));
}

int strdcmp(char *opt1,char *opt2)
{
//str-deep-cmp!
	if(strlen(opt1)!=strlen(opt2))return(-1);
	if(strncmp(opt1,opt2,strlen(opt1))!=0)return(-1);
	return(0);
//	((strlen(opt1)!=strlen(opt2))||(strncmp(opt1,opt2,strlen(opt1))!=0))?return(-1):return(0);
}

int stricmp(char *opt1,char *opt2)
{
//case insensitive
	if(strlen(opt1)!=strlen(opt2))return(-1);
	while(*opt1==*opt2||*opt1==*opt2+0x20||*opt1==*opt2-0x20){opt1++;opt2++;}
	if(*opt1==0&&*opt2==0)return(0);
	return(-1);
}

char *stpblk(char *str)
{
	while(*str==32)str++;
	return(str);
}

char *stprblk(char *str1,char *str2)
{
	register long x;
	str1[0]=0;
	
	x=strlen(str2)-1;
	while(x>-1&&str2[x]==32)x--;
	x++;
	return(strncat(str1,str2,x));
}

char *stptab(char *str)
{
	while(*str=='\t')str++;
	return(str);
}

char *stpblks(char *str)
{
	while(*str=='\t'||*str==32)str++;
	return(str);
}

void strrncpy(char *str,char *str2,long n)
{
//str-reverse-n-cpy (strips n chars from the beginning and takes care of tabs)

	if(strspn(str2,"\t")!=0)
	{
		str[0]=0;
		while(*str2)
		{
			if(*str2=='\t')strcat(str,"        ");
			else strncat(str,str2,1);
			str2++;
		}
		strcpy(str2,str);
	}
	strcpy(str,&str2[n-1]);
}

char *strupr(char *str)
{
	char *ustr=str;
	while(*str)
	{
		*str=toupper(*str);
		str++;
	}
	return(ustr);
}
                                                        
char *strlwr(char *str)
{
	char *lstr=str;
	while(*str)
	{
		*str=tolower(*str);
		str++;
	}
	return(lstr);
}

char *stplcr(char *str)
{
	while(*str!=0x00&&*str!=0x0a&&*str!=0x0d)str++;
	*str=0;
	return(str);
}

/*
#define strext(x,y) (strrchr(x,'.'))?strcpy(strrchr(x,'.'),\
(\
y\
)\
):strcat(x,\
(\
y\
)\
)
*/

//#define strdos(x) strcat(stplcr(x),"\n")
char *strdos(char *str)
{
	stplcr(str);
	strcat(str,"\n");
	return(str);
}

char *strhtml(char *str)
{
//mitten in zeile ersetzen
//frames support
	int ignore=0,x=0;
	char buf[4096],buf2[4096],buf3[4096];

	stplcr(str);
	strcpy(buf2,str);
	
	if(!access(buf2,F_OK))
	{
		
//		if(stricmp(&buf2[strcspn(buf2,".")],"jpg")||stricmp(&buf2[strcspn(buf2,".")],"gif"))			sprintf(str,"<img src=\"%s\">",buf2);
//		else 
sprintf(str,"<a href=\"%s\">%s</a>",buf2,buf2);
	}
	else if(strchr(buf2,32)!=NULL)
	{
		strcpy(buf3,buf2);
		buf3[strcspn(buf3," ")]=0;
		if(!access(buf3,F_OK))
		{
			sprintf(str,"<a href=\"%s\">%s</a>%s",buf3,buf3,&buf2[strcspn(buf2," ")]);
		}
	}

	x=strlen(str);
	buf2[0]=0;
	while(*str)
	{
		buf[0]=0;

		if(*str=='>')ignore=0;
		if(!ignore)
		{
			if(*str=='<')ignore=1;
			if(*str==32)strcpy(buf,"&nbsp;");//nicht bei nur einem space
			if(*str=='\t')
			{
				while(!((x-strlen(str))%8))
				strcat(buf,"&nbsp;");
//				strcpy(buf,"&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;");
			}
		}
		
		if(!buf[0])sprintf(buf,"%c",*str);

		strcat(buf2,buf);
		str++;
	}
	strcat(buf2,"<br>\n");

	strcpy(str,buf2);
	return(str);
}

/*
int fsystem(char *cmd)
{
//with function to measure the time
int status;
char buf[BUFSIZE];
time_t t=0;
unsigned long total[2],user,system,nice,idle[2];
int fd;

if((fd=open("/proc/stat",O_RDONLY))==-1)return(-1);
if(read(fd,buf,BUFSIZE)<1)
{
	close(fd);
	return(-1);
}
                
sscanf(buf,"%*s %lu %lu %lu %lu\n",&user,&nice,&system,&idle[0]);
total[0]=user+nice+system+idle[0];

if(cmd[0]!=0)
{
	t=time(0);
	status=system(cmd);
	t=time(0)-t;
}
else sleep(1);

lseek(fd,0,SEEK_SET);
if(read(fd,buf,BUFSIZE)<1)
{	
	close(fd);
	return(-1);
}
close(fd);

total[1]=idle[1]=0;
sscanf(buf,"%*s %lu %lu %lu %lu\n",&user,&nice,&system,&idle[1]);
total[1]=user+nice+system+idle[1];

if(cmd[0]!=0)
{
	strftime(buf,15,"%H:%M:%S   ",gmtime(&t));
	printf("%s: TIME: %s CPU: %d\%\n",cmd,buf,(100-(100*(idle[1]-idle[0])/(total[1]-total[0])))/t);
	return(status);
}
else
{
	printf("CPU: %d\%\n",(100-(100*(idle[1]-idle[0])/(total[1]-total[0]))));
	return(0);
}
} 
*/

/*char *fmalloc(char *fname,long fstart)
{
	return((char *)malloc((fsize(fname,fstart)+2)*sizeof(char))));
}*/

int fstrlwr(char *dir)
{
struct dirent *ep;
struct stat puffer;
DIR *dp;
char buf[BUFSIZE];

if(access(dir,R_OK)==-1)return(-1);
if((dp=opendir(dir))==NULL)return(-1);
chdir(dir);

while((ep=readdir(dp))!=0)
{
                if(!stat(ep->d_name,&puffer))
		{
//			if(S_ISREG(puffer.st_mode)==1)
			{
				strcpy(buf,ep->d_name);
				rename(ep->d_name,strlwr(buf));
			}
		}                
}
 (void)closedir(dp);
	return(0);
}

long fchksum(char *fname,long fstart,int chksum_len)
{
/*
// calculate CRC for data address marks or sector data
static void calc_crc(UINT16 * crc, UINT8 value)
{
UINT8 l, h;

	l = value ^ (*crc >> 8);
	*crc = (*crc & 0xff) | (l << 8);
	l >>= 4;
	l ^= (*crc >> 8);
	*crc <<= 8;
	*crc = (*crc & 0xff00) | l;
	l = (l << 4) | (l >> 4);
	h = l;
	l = (l << 2) | (l >> 6);
	l &= 0x1f;
	*crc = *crc ^ (l << 8);
	l = h & 0xf0;
	*crc = *crc ^ (l << 8);
	l = (h << 1) | (h >> 7);
	l &= 0xe0;
	*crc = *crc ^ l;
}


*/

//adds all bytes of NAME to create a pseudo chksum
//CRC16 CRC32 !??!

FILE *fh;
register long x,y;
char buf[BUFSIZE];
unsigned long chksum=0;

if(!(fh=fopen(fname,"rb")))return(-1);
fseek(fh,fstart,SEEK_SET);

while(fread(buf,1,chksum_len,fh)>0)
{
	for(x=0;x<chksum_len;x++)
	{
		chksum+=((buf[x])<<(x*8));
	}
}

fclose(fh);

y=0;
for(x=0;x<chksum_len;x++)
{
	y=y<<8;
	y=y+0x0ff;
}
return(chksum&y);
}

      
int fgauge(long fpos,long fsize)
{
#ifdef LINUX
#define START 0
	long cps=0;
	time_t curr,left;
	static time_t fgtstart;
	char buf[256];
	
	if(fpos==START)
	{
		fgtstart=time(0);
		return(0);
	}

	curr=time(0)-fgtstart;
	if(curr!=0)
	{
		cps=fpos/curr;
		left=(fsize-fpos)/cps;

		buf[0]=0;
		strncat(buf,"===============================",(size_t)((long)24*fpos/fsize));
		strcat(buf,"-------------------------------");
		buf[24]=0;

		printf("\r%10lu bytes [%s] %lu%%, CPS=%lu, ",fpos,buf,(unsigned int)100*fpos/fsize,(unsigned long)cps);
if(fpos==fsize)
		printf("TOTAL=%03ld:%02ld ",(long)(curr/60),((long)curr)%60);
else 		printf("ETA=%03ld:%02ld   ",(long)(left/60),((long)left)%60);

		fflush(stdout);
	}
#else
	printf(".");
	fflush(stdout);
#endif
	return(0);
}


#ifdef CURSES
int fdialog(char *emptystr,char *dir,char *wc,long ystart,long ylen)
{
struct dirent *ep;
struct stat puffer;
struct menues
{
	unsigned long fpos;
	char fname[80];
	time_t ctime;
	off_t size;
	mode_t mode;
}*menues;
DIR *dp;
char buf[4096];
char wildcard[4096];
register long x,xx;
unsigned long fpos2;
static long fdialogpos;
int key;
register long u,y=0,dlen=0,flen=0,mlen=0;




x=xx=0;
strcpy(wildcard,wc);
strupr(wildcard);

if(access(dir,R_OK)==-1)return(-1);
if((dp=opendir(dir))==NULL)return(-1);
chdir(dir);

while((ep=readdir(dp))!=0)
{
	if(!stat(ep->d_name,&puffer))
	{
		if(S_ISDIR(puffer.st_mode)==1)dlen++;
		else if(S_ISREG(puffer.st_mode)==1)
		{
			if(!wildcard[0])flen++;
			else
			{
				strcpy(buf,ep->d_name);
				strupr(buf);
				if(strstr(buf,wildcard)!=0)flen++;
			}
		}
	}
}
rewinddir(dp);
mlen=dlen+flen;
if(!(menues=(struct menues *)malloc((mlen+2)*sizeof(struct menues))))
	return(-1);

for(x=0;x<dlen;)
{
	if((ep=readdir(dp))!=0)
	{
		if(!stat(ep->d_name,&puffer))
		{
			if(S_ISDIR(puffer.st_mode)==1)
			{
				(menues+x)->ctime=puffer.st_ctime;
				(menues+x)->mode=puffer.st_mode;
				(menues+x)->size=puffer.st_size;
				strncpy((menues+x)->fname,ep->d_name,sizeof((menues+x)->fname)-1);
				(menues+x)->fname[sizeof((menues+x)->fname)-1]=0;
				x++;
			}
		}
	}else break;
}
dlen=x;
rewinddir(dp);
for(x=dlen;x<dlen+flen;)
{
	if((ep=readdir(dp))!=0)
	{
		if(!stat(ep->d_name,&puffer))
		{
			if(S_ISREG(puffer.st_mode)==1)
			{
				if(!wildcard[0])
				{
					(menues+x)->ctime=puffer.st_ctime;
					(menues+x)->mode=puffer.st_mode;
					(menues+x)->size=puffer.st_size;
					strncpy((menues+x)->fname,ep->d_name,sizeof((menues+x)->fname));
					(menues+x)->fname[sizeof((menues+x)->fname)-1]=0;
					x++;
				}
				else
				{
					strcpy(buf,ep->d_name);
					strupr(buf);
					if(strstr(buf,wildcard)!=0)
					{
						(menues+x)->ctime=puffer.st_ctime;
						(menues+x)->mode=puffer.st_mode;
						(menues+x)->size=puffer.st_size;
						strncpy((menues+x)->fname,ep->d_name,sizeof((menues+x)->fname));
						(menues+x)->fname[sizeof((menues+x)->fname)-1]=0;
						x++;
					}
				}
			}
		}
	}else break;
}
flen=x-dlen;
mlen=dlen+flen;
if(fdialogpos>mlen)fdialogpos=0;
	(void)closedir(dp);

for(x=0;x<mlen;x++)(menues+x)->fpos=x;

for(y=4;y>-1;y--)
{
for(x=dlen-1;x>0;x--)
{
	for(xx=1;xx<=x;xx++)
	{
if(toupper((menues+(menues+xx-1)->fpos)->fname[y])>toupper((menues+(menues+xx)->fpos)->fname[y]))
		{
			fpos2=(menues+xx-1)->fpos;
			(menues+xx-1)->fpos=(menues+xx)->fpos;
			(menues+xx)->fpos=fpos2;
		}
	}
}
}


for(y=4;y>-1;y--)
{
for(x=dlen+flen-1;x>dlen;x--)
{
	for(xx=dlen+1;xx<=x;xx++)
	{
if(toupper((menues+(menues+xx-1)->fpos)->fname[y])>toupper((menues+(menues+xx)->fpos)->fname[y]))
		{
			fpos2=(menues+xx-1)->fpos;
			(menues+xx-1)->fpos=(menues+xx)->fpos;
			(menues+xx)->fpos=fpos2;
		}
	}
}
}

//make .. stand before .
fpos2=(menues)->fpos;
(menues)->fpos=(menues+1)->fpos;
(menues+1)->fpos=fpos2;


//start curses
		initscr();
		clear();
		keypad(stdscr,1);
//		cbreak();
		noecho();

		attrset(0);
//		refresh();




	for(;;)
	{
		for(x=0;x<ylen;x++)
		{
			if(x==(long)ylen/2)attron(A_REVERSE);

			u=((long)(fdialogpos+x-(long)ylen/2));
			if(u>(long)-1&&u<mlen)
			{
					strftime(buf,15," %b %2d %02H:%02M       ",localtime(&(menues+(menues+u)->fpos)->ctime));
					buf[14]=0;
					if(S_ISDIR((menues+(menues+u)->fpos)->mode)==1)
					{
//						attron(A_BLINK);
						mvprintw(ystart+x,0,"%-12.12s%14s%-54.54s","",buf,(menues+(menues+u)->fpos)->fname);
//						attroff(A_BLINK);
					}
					else
					{
//						attron(A_BOLD);
						mvprintw(ystart+x,0,"%12lu%14s%-54.54s",(menues+(menues+u)->fpos)->size,buf,(menues+(menues+u)->fpos)->fname);
//						attroff(A_BOLD);
					}
			}
			else mvprintw(ystart+x,0,"%-80.80s"," ");

			if(x==(long)ylen/2)attroff(A_REVERSE);
		}
		refresh();

key=getch();
//mvprintw(0,0,"%d",key);

		switch(key)
		{


			case 262:
				fdialogpos=0;
			break;
			
			case 360:
				fdialogpos=mlen-1;
			break;
			
			case KEY_UP:
				fdialogpos--;
				if(fdialogpos<0)fdialogpos=0;
			break;

			case KEY_DOWN:
				fdialogpos++;
				if(fdialogpos>mlen-1)fdialogpos=mlen-1;
			break;

			case 338:
			case KEY_RIGHT:
				fdialogpos=fdialogpos+ylen;
				if(fdialogpos>mlen-1)fdialogpos=mlen-1;
			break;

			case 339:
			case KEY_LEFT:
				fdialogpos=fdialogpos-ylen;
				if(fdialogpos<0)fdialogpos=0;
			break;

			case 27://esc
				strcpy(emptystr,"");
				free(menues);

		clear();
		refresh();
		endwin();
		return(0);


				fprintf(stderr,emptystr);
				return(0);
			break;

			case 10://return
				if(S_ISDIR((menues+(menues+fdialogpos)->fpos)->mode)==1)
				{
					fdialog(emptystr,(menues+(menues+fdialogpos)->fpos)->fname,wildcard,ystart,ylen);
				}
				else sprintf(emptystr,"\"%s\"",stpblk((menues+(menues+fdialogpos)->fpos)->fname));
				free(menues);


		clear();
		refresh();
		endwin();
		return(0);


				fprintf(stderr,emptystr);
				return(0);
			break;

			default:
			break;
		}
	}
}
#endif

#define MBIT 131072

long fseek2(char *name,long skip,int how)
{
	char buf[4096];
	long size=0;
	FILE *fh;

	strcpy(buf,name);
	while((fh=fopen(buf,"rb")))
	{
		fseek(fh,skip,how);
		size=size+ftell(fh);
		fclose(fh);

//(md and snes copiers splitted fnames to put them onto disks)
		if(!skip)buf[strcspn(buf,".")-1]++;
		else buf[strcspn(buf,".")+1]++;

	}
	return(size);
}

#define fsize(x,y)	(fseek2(x,-1*y,SEEK_END))
//#define fsize(x,y)      (fseek2(x,0,SEEK_END)-y)

int fstrncmp(char *kett1,char *kett2,unsigned long kett_len)
{
//continues even when kettX is terminated
	register unsigned long x;
	x=0;

	while(x<kett_len)
	{
//		if(kett1[x]>kett2[x])return(1);
                if((int)(kett1[x]&0xff)!=(int)(kett2[x]&0xff))return(-1);
		x++;
	}
	return(0);
}

/*long fstrstr(char *fname,char *search,long fstart,long slen)
{
	register unsigned long x,y;
	size_t size;
//	long size2;
	char buf[BUFSIZE];
	FILE *fh;

	if(!(fh=fopen(fname,"rb")))return(-1);

//	fseek(fh,0,SEEK_END);
//	size2=ftell(fh);
	
	if(fseek(fh,fstart+len,SEEK_SET)!=0)
	{
		fclose(fh);
		return(-1);
	}

	for(x=0;;x++)
	{
		if(fseek(fh,-len,SEEK_CUR)!=0)break;
		memset(buf,0,BUFSIZE);
		if(!(size=fread(buf,1,BUFSIZE,fh)))
		{
			fclose(fh);
			break;
		}

		for(y=0;y<size;y++)if(!strncmp(&buf[y],search,len))
		{
			fclose(fh);
			return((start+(x*BUFSIZE)+y));
		}
	}
	return(-1);
}*/

long fstrstr(char *fname,char *search,long fstart,long slen)//fstrnstr
{
	register unsigned long x,y;
	char *buf;
	FILE *fh;
x=0;
	if(!(fh=fopen(fname,"rb")))return(-1);

	if(!(buf=(char *)malloc((fsize(fname,fstart)+2)*sizeof(char))))
	{
		fclose(fh);
	        return(-1);
	}

	fseek(fh,fstart,SEEK_SET);
	if(!fread(buf,fsize(fname,fstart),1,fh))
	{
		free(buf);
		fclose(fh);
		return(-1);
	}	

	fclose(fh);

	y=fsize(fname,fstart);
	while((x+slen)<y)
	{
		if(!fstrncmp(&buf[x],search,slen))return(x+fstart);
		x++;
	}
	free(buf);
	return(-1);
}

long fstrncpy(char *dest,char *source,long sstart,long slen)
{
	int x=0;
	long y=0;
	FILE *fh;
	
	if((fh=fopen(dest,"r+b"))!=0)x++;		//char>file
	else if(!(fh=fopen(source,"rb")))		//file>char
	{
		strncpy(dest,&source[sstart],slen);	//char>char
		dest[slen]=0;
		return(slen);
	}
//	else if((fh=fopen(dest,"wb"))!=0)x++;
	
	fseek(fh,sstart,SEEK_SET);
	if(!x)
	{
		y=fread(dest,slen,1,fh);
		dest[slen]=0;
	}
	else y=fwrite(source,slen,1,fh);
	fclose(fh);
	return(y);
}

int fswap(char *name,long start,long len)
{
	register unsigned long x;
	size_t size;
	int failed=0;
	FILE  *fh,*fh2=0;
	char buf[BUFSIZE],buf2[3],buf3;
	
	if(!(fh=fopen(name,"rb")))failed=1;
	if(!failed)
	{
		strcpy(buf,name);
		buf[strcspn(buf,".")+1]=0;
		strcat(buf,"tmp");
	                                        
		if(!(fh2=fopen(buf,"wb")))
		{
			fclose(fh);
			return(-1);
		}
	
		fseek(fh,start,SEEK_SET);
	}
	for(x=0;x<(len-start);x=x+2)
	{
		if(!failed)
		{	
			if(!fread(buf2,2,1,fh))break;
			buf3=buf2[0];
			buf2[0]=buf2[1];
			buf2[1]=buf3;
			fwrite(buf2,2,1,fh2);
		}
		else
		{
			buf3=name[x+start];
			name[x+start]=name[x+1+start];
			name[x+1+start]=buf3;
		}
	}
	if(!failed)
	{
		size=(len-start)%2;
		fread(buf2,size,1,fh);
		fwrite(buf2,size,1,fh2);
		fclose(fh);
		fclose(fh2);
		
		remove(name);
		rename(buf,name);
	}
	return(0);
}

int fgetc2(char *name,long pos)
{
	int c;
	FILE *fh;

        if(!(fh=fopen(name,"rb")))return(EOF);
	if(fseek(fh,pos,SEEK_SET)!=0)return(EOF);
	c=fgetc(fh);
	fclose(fh);
	
	return(c);
}

int fhexdump(char *name,long start,long len)
{
//wenn name[0]=0; dann memdump!
	register long x;
	char buf[256];
	int dump;
	int failed=0;
	FILE *fh;

	if(!(fh=fopen(name,"rb")))failed=1;
	if(!failed)fseek(fh,start,SEEK_SET);
	
	buf[16]=0;
	for(x=0;x<len;x++)
	{
		if(x!=0&&!(x%16))printf("%s\n",buf);
		if(!x||!(x%16))printf("%08lx  ",x+start);
		dump=(!failed)?fgetc2(name,start+x):name[start+x];
		printf("%02x ",dump&0xff);
		if(!((x+1)%4))printf(" "); 
		buf[(x%16)]=isprint(dump)?dump:'.';
		buf[(x%16)+1]=0;
	}
	printf("%s\n",buf);
	if(!failed)fclose(fh);
	return(0);
}

long fpad(char *name,long start,char *mode)
{
	size_t size;
	register long x;
	int y;
	char *buf;
	FILE *fh;
	
	if(!islower(mode[0]))return(-1);

	if(mode[0]=='r')//counts the size of the pad (if padded)
	{
		if(!(fh=fopen(name,mode)))return(-1);
		if(!(buf=(char *)malloc((fsize(name,0)+2)*sizeof(char))))
		{
			fclose(fh);
        		return(-1);
		}
		if(!fread(buf,fsize(name,0),1,fh))
		{
			fclose(fh);
			free(buf);
			return(-1);
		}
		fclose(fh);

		y=buf[fsize(name,0)-1]&0xff;
		x=fsize(name,0)-2;
		while(y==(buf[x]&0xff))x--;//x-=2;
//		if(y!=(buf[x+1]&0xff))x++;

		free(buf);
		if(((fsize(name,0)-x)-1)==1)return(0);
		return((fsize(name,0)-x)-1);
	}
	size=fsize(name,start);

	if(!(size%MBIT))return(size);

	size=(size_t)size/MBIT;
	size=size+1;
	size=size*MBIT;

	truncate(name,size+start);
	return(size);
}

#define fcopy0(a,b) f_copy(a,0,0,b,"wb")
#define fcopy(a,b,c,d) f_copy(a,b,0,c,d)
#define fcopy3(a,b,c,d,e) f_copy(a,b,c,d,e)
int f_copy(char *s_name,long s_start,long s_len,char *d_name,char *mode)
{
	long size,ab_size=0;
	char buf[BUFSIZE];
	FILE *fh,*fh2;

        if(!islower(mode[0]))return(-1);

	if(mode[0]=='a')ab_size=fsize(d_name,0);

//if(!strdcmp(d_name,sname))return(-1);

	if(!(fh=fopen(s_name,"rb")))return(-1);
	if(!(fh2=fopen(d_name,mode)))
	{
	        fclose(fh);
		return(-1);
	}

	fseek(fh,0,SEEK_END);
	size=(ftell(fh)-s_start)%BUFSIZE;
	fseek(fh,s_start,SEEK_SET);
	fseek(fh2,0,SEEK_END);
	while(fread(buf,BUFSIZE,1,fh))fwrite(buf,BUFSIZE,1,fh2);
	fread(buf,size,1,fh);
	fwrite(buf,size,1,fh2);
		
	fclose(fh);
	fclose(fh2);


	if(s_len!=0)
	{
	if(s_len<fsize(d_name,0))
	truncate(d_name,s_len+ab_size);
}

	return(0);
}

/*
int fbackup(char *name)
{
	char buf[BUFSIZE];
if(access(name,F_OK)!=0)return(-1);
	strcpy(buf,name);
	strcat(buf,"\~");
//	while(access(buf,F_OK)!=0)
	{
		fcopy0(name,buf);
		
//(md and snes copiers splitted fnames to put them onto disks)
//		if(!skip)buf[strcspn(buf,".")-1]++;
//		else buf[strcspn(buf,".")+1]++;
//		break;
	}
	return(0);
}
*/
/*
#ifndef CDROM_LEADOUT
#define CDROM_LEADOUT (0xAA)
#endif
#define FS_NO_DATA              0
#define FS_HIGH_SIERRA		1
#define FS_ISO_9660		2
#define FS_INTERACTIVE		3
#define FS_HFS			4
#define FS_UFS			5
#define FS_EXT2			6
#define FS_ISO_HFS              7
#define FS_ISO_9660_INTERACTIVE 8
#define FS_3DO			9
#define FS_UNKNOWN	       15
#define FS_MASK		       15

#define XA		       16
#define MULTISESSION	       32
#define PHOTO_CD	       64
#define HIDDEN_TRACK          128
#define CDTV		      256
#define BOOTABLE       	      512
#define VIDEOCDI       	     1024
#define ROCKRIDGE            2048
#define JOLIET               4096

#if 0
#define STRONG "\033[1m"
#define NORMAL "\033[0m"
#else
#define STRONG ""
#define NORMAL ""
#endif

int filehandle;            
int rc;                    
int i,j;                   
int isofs_size = 0;        
int start_track;           
int ms_offset;             
int data_start;            
int joliet_level = 0;

char buffer[2048];         
char buffer2[2048];        
char buffer3[2048];        
char buffer4[2048];        
char buffer5[2048];        

char                       toc_header[2]; 
struct cdrom_tocentry      *toc[CDROM_LEADOUT+1];
struct cdrom_mcn           mcn;
struct cdrom_multisession  ms;
struct cdrom_subchnl       sub;
int                        first_data = -1;      
int                        num_data = 0;         
int                        first_audio = -1;     
int                        num_audio = 0;        

#define DEBUG 0
int read_super(int offset)
{
    memset(buffer,0,2048);
    if (0 > lseek(filehandle,2048*(offset+16),SEEK_SET))return -1;
    if (0 > read(filehandle,buffer,2048))return -1;
    return 0;
}

int read_super2(int offset)
{
    memset(buffer2,0,2048);
    if (0 > lseek(filehandle,2048*(offset+0),SEEK_SET))return -1;
    if (0 > read(filehandle,buffer2,2048))return -1;
    return 0;
}

int read_super3(int offset)
{
    memset(buffer3,0,2048);
    if (0 > lseek(filehandle,2048*(offset+4),SEEK_SET))return -1;
    if (0 > read(filehandle,buffer3,2048))return -1;
    return 0;
}

int read_super4(int offset)
{
    memset(buffer4,0,2048);
    if (0 > lseek(filehandle,2048*(offset+17),SEEK_SET))return -1;
    if (0 > read(filehandle,buffer4,2048))return -1;
    return 0;
}

int read_super5(int offset)
{
    memset(buffer5,0,2048);
    if (0 > lseek(filehandle,2048*(offset+150),SEEK_SET))return -1;
    if (0 > read(filehandle,buffer5,2048))return -1;
    return 0;
}

#define is_isofs()	(0 == memcmp(&buffer[1],"CD001",5))
#define is_hs()		(0 == memcmp(&buffer[9],"CDROM",5))
#define is_cdi()	(0 == memcmp(&buffer[1],"CD-I",4))
#define is_cd_rtos()	(0 == memcmp(&buffer[8],"CD-RTOS",7))
#define is_bridge()	(0 == memcmp(&buffer[16],"CD-BRIDGE",9))
#define is_xa()		(0 == memcmp(&buffer[1024],"CD-XA001",8))
#define is_cdtv()	(0 == memcmp(&buffer[8],"CDTV",4))
#define is_photocd()	(0 == memcmp(&buffer2[64], "PPPPHHHHOOOOTTTTOOOO____CCCCDDDD", 24))
#define is_hfs()	((0 == memcmp(&buffer2[512],"PM",2)) ||\
           (0 == memcmp(&buffer2[512],"TS",2)) ||\
	   (0 == memcmp(&buffer2[1024], "BD",2)))
#define is_ext2()	(0 == memcmp(&buffer2[0x438],"\x53\xef",2))
#define is_3do()	((0 == memcmp(&buffer2[0],"\x01\x5a\x5a\x5a\x5a\x5a\x01", 7)) &&\
           (0 == memcmp(&buffer2[40], "CD-ROM", 6)))
#define is_ufs()	(0 == memcmp(&buffer3[1372],"\x54\x19\x01\x0" ,4))
#define is_bootable()	(0 == memcmp(&buffer4[7],"EL TORITO",9))
#define is_joliet()	(2 == buffer4[0] && buffer4[88] == 0x25 && buffer4[89] == 0x2f)
#define is_video_cdi()	(0 == memcmp(&buffer5[0],"VIDEO_CD",8))

int get_size(void)
{
    return ((buffer[80] & 0xff) |
	    ((buffer[81] & 0xff) << 8) |
	    ((buffer[82] & 0xff) << 16) |
	    ((buffer[83] & 0xff) << 24));
}

int get_joliet_level( void )
{
	switch (buffer4[90]) {
		case 0x40: return 1;
		case 0x43: return 2;
		case 0x45: return 3;
	}
	return 0;
}

int guess_filesystem(int start_session)
{
    int ret = 0;

    if (read_super(start_session) < 0)
	return ret;


    if (is_cdi() && is_cd_rtos() && !is_bridge() && !is_xa()) {
        return FS_INTERACTIVE;
    } else {

        if (read_super2(start_session) < 0)
	    return ret;

        if (is_hs())
	    ret |= FS_HIGH_SIERRA;
	else if (is_isofs()) {
	    if (is_cd_rtos() && is_bridge())
	        ret = FS_ISO_9660_INTERACTIVE;
	    else if (is_hfs())
	        ret = FS_ISO_HFS;
	    else
	        ret = FS_ISO_9660;
	    isofs_size = get_size();
#if 0
	    if (is_rockridge())
		ret |= ROCKRIDGE;
#endif
            if (read_super4(start_session) < 0)
	        return ret;

	    if (is_joliet()) {
		joliet_level = get_joliet_level();
	        ret |= JOLIET;
	    }
	    if (is_bootable())
		ret |= BOOTABLE;

	    if (is_bridge() && is_xa() && is_isofs() && is_cd_rtos() &&
                !is_photocd()) {
                if (read_super5(start_session) < 0)
	            return ret;

		if (is_video_cdi())
		    ret |= VIDEOCDI;
	    }
	} else if (is_hfs())
	    ret |= FS_HFS;
	else if (is_ext2())
	    ret |= FS_EXT2;
	else if (is_3do())
	    ret |= FS_3DO;
	else {

            if (read_super3(start_session) < 0)
	        return ret;

	    if (is_ufs())
	        ret |= FS_UFS;
	    else
	        ret |= FS_UNKNOWN;
	}
    }
    if (is_xa())
        ret |= XA;
    if (is_photocd())
	ret |= PHOTO_CD;
    if (is_cdtv())
	ret |= CDTV;
    return ret;
}

int
cddb_sum(int n)
{
    int ret=0;
    
    for (;;) {
	ret += n%10;
	n    = n/10;
	if (!n)
	    return ret;
    }
}

unsigned long
cddb_discid()
{
    int i,t,n=0;

    for (i = 1; i <= toc_header[1]; i++) {
	n += cddb_sum(toc[i]->cdte_addr.msf.minute * 60 +
		      toc[i]->cdte_addr.msf.second);
    }
    
    t = + toc[CDROM_LEADOUT]->cdte_addr.msf.minute * 60 
	+ toc[CDROM_LEADOUT]->cdte_addr.msf.second
	- toc[1]->cdte_addr.msf.minute * 60 
	- toc[1]->cdte_addr.msf.second;

    return ((n % 0xff) << 24 | t << 8 | toc_header[1]);
}


int
cdinfo(char *devname)
{
    int fs=0;
    int need_lf;

    filehandle = open(devname,O_RDONLY);
    if (filehandle == -1) {
	return(-1);
    }

#ifdef CDROMREADTOCHDR
    if (ioctl(filehandle,CDROMREADTOCHDR,&toc_header)) {
	return(-1);
    }
    
    printf(STRONG "track list (%i - %i)\n" NORMAL,
	   toc_header[0],toc_header[1]);
    
    printf(" nr: msf      lba      ctrl adr  type\n");
    for (i = toc_header[0]; i <= CDROM_LEADOUT; i++) {
	toc[i] = malloc(sizeof(struct cdrom_tocentry));
	if (toc[i] == NULL) {
	    fprintf(stderr, "out of memory\n");
	    return(-1);
	}
	memset(toc[i],0,sizeof(struct cdrom_tocentry));
	toc[i]->cdte_track  = i;
	toc[i]->cdte_format = CDROM_MSF;
	if (ioctl(filehandle,CDROMREADTOCENTRY,toc[i])) {
	    return(-1);
	}
	printf("%3d: %02d:%02d:%02d (%06d) 0x%x 0x%x %s%s\n",
	       (int)toc[i]->cdte_track,
	       (int)toc[i]->cdte_addr.msf.minute,
	       (int)toc[i]->cdte_addr.msf.second,
	       (int)toc[i]->cdte_addr.msf.frame,
	       (int)toc[i]->cdte_addr.msf.frame +
	       (int)toc[i]->cdte_addr.msf.second*75 + 
	       (int)toc[i]->cdte_addr.msf.minute*75*60 - 150,
	       (int)toc[i]->cdte_ctrl,
	       (int)toc[i]->cdte_adr,
	       (toc[i]->cdte_ctrl & CDROM_DATA_TRACK) ? "data ":"audio",
	       CDROM_LEADOUT == i ? " (leadout)" : "");
	if (i == CDROM_LEADOUT)
	    break;
	if (toc[i]->cdte_ctrl & CDROM_DATA_TRACK) {
	    num_data++;
	    if (-1 == first_data)
		first_data = toc[i]->cdte_track;
	} else {
	    num_audio++;
	    if (-1 == first_audio)
		first_audio = toc[i]->cdte_track;
	}
	if (i == (int)(toc_header[1]))
	    i = CDROM_LEADOUT-1;
    }
#endif 
    printf(STRONG "what ioctl's report\n" NORMAL);

#ifdef CDROM_GET_MCN
    printf("get mcn     : "); fflush(stdout);
    if (ioctl(filehandle,CDROM_GET_MCN,&mcn))
	printf("FAILED\n");
    else
	printf("%s\n",mcn.medium_catalog_number);
#endif

#ifdef CDROM_DISC_STATUS
    printf("disc status : "); fflush(stdout);
    switch (ioctl(filehandle,CDROM_DISC_STATUS,0)) {
    case CDS_NO_INFO: printf("no info\n"); break;
    case CDS_NO_DISC: printf("no disc\n"); break;
    case CDS_AUDIO:   printf("audio\n"); break;
    case CDS_DATA_1:  printf("data mode 1\n"); break;
    case CDS_DATA_2:  printf("data mode 2\n"); break;
    case CDS_XA_2_1:  printf("XA mode 1\n"); break;
    case CDS_XA_2_2:  printf("XA mode 2\n"); break;
    default:          printf("unknown (failed?)\n");
    }
#endif 
    
#ifdef CDROMMULTISESSION
    printf("multisession: "); fflush(stdout);
    ms.addr_format = CDROM_LBA;
    if (ioctl(filehandle,CDROMMULTISESSION,&ms))
	printf("FAILED\n");
    else
	printf("%d%s\n",ms.addr.lba,ms.xa_flag?" XA":"");
#endif 

#ifdef CDROMSUBCHNL
    printf("audio status: "); fflush(stdout);
    sub.cdsc_format = CDROM_MSF;
    if (ioctl(filehandle,CDROMSUBCHNL,&sub))
	printf("FAILED\n");
    else {
	switch (sub.cdsc_audiostatus) {
	case CDROM_AUDIO_INVALID:    printf("invalid\n");   break;
	case CDROM_AUDIO_PLAY:       printf("playing");     break;
	case CDROM_AUDIO_PAUSED:     printf("paused");      break;
	case CDROM_AUDIO_COMPLETED:  printf("completed\n"); break;
	case CDROM_AUDIO_ERROR:      printf("error\n");     break;
	case CDROM_AUDIO_NO_STATUS:  printf("no status\n"); break;
	default:                     printf("Oops: unknown\n");
	}
	if (sub.cdsc_audiostatus == CDROM_AUDIO_PLAY ||
	    sub.cdsc_audiostatus == CDROM_AUDIO_PAUSED) {
	    printf(" at: %02d:%02d abs / %02d:%02d track %d\n",
		   sub.cdsc_absaddr.msf.minute,
		   sub.cdsc_absaddr.msf.second,
		   sub.cdsc_reladdr.msf.minute,
		   sub.cdsc_reladdr.msf.second,
		   sub.cdsc_trk);
	}
    }
#endif 
    printf(STRONG "try to find out what sort of CD this is\n" NORMAL);

    if (0 == num_data) {
	start_track = (int)toc[1]->cdte_addr.msf.frame +
	    (int)toc[1]->cdte_addr.msf.second*75 + 
	    (int)toc[1]->cdte_addr.msf.minute*75*60 - 150;
	if (start_track > 100) {
	    fs = guess_filesystem(0);
	    if ((fs & FS_MASK) != FS_UNKNOWN)
		fs |= HIDDEN_TRACK;
	    else {
		fs &= ~FS_MASK; 
		printf("Oops: %i unused sectors at start, but hidden track check failed.\n",start_track);
	    }
	}
    } else {
	for (j = 2, i = first_data; i <= toc_header[1]; i++) {
	    if (!(toc[i]->cdte_ctrl & CDROM_DATA_TRACK))
	        break;
	    start_track = (i == 1) ? 0 :
		    (int)toc[i]->cdte_addr.msf.frame +
		    (int)toc[i]->cdte_addr.msf.second*75 + 
		    (int)toc[i]->cdte_addr.msf.minute*75*60
		    -150;
	    if (i == first_data)
	        data_start = start_track;
	    
	    if (start_track < data_start + isofs_size)
	        continue;

	    fs = guess_filesystem(start_track);
	    if (!(((fs & FS_MASK) == FS_ISO_9660 ||
		   (fs & FS_MASK) == FS_ISO_HFS ||
		   (fs & FS_MASK) == FS_ISO_9660_INTERACTIVE)))
	        break;	

	    if (i > 1) {
		ms_offset = start_track;
		printf("session #%d starts at track %2i, offset %6i, isofs size %6i\n",
		       j++,toc[i]->cdte_track,start_track,isofs_size);
		printf("iso9660: %i MB size, label `%.32s'\n",
		       isofs_size/512,buffer+40);
		fs |= MULTISESSION;
	    }
	}
    }

    switch(fs & FS_MASK) {
    case FS_NO_DATA:
	if (num_audio > 0)
	    printf("Audio CD, cddb disc ID is %08lx\n",cddb_discid());
	break;
    case FS_ISO_9660:
	printf("CD-ROM with iso9660 fs");
	if (fs & JOLIET)
	   printf(" and joliet extension level %d", joliet_level);
	if (fs & ROCKRIDGE)
	   printf(" and rockridge extensions");
	printf("\n");
	break;
    case FS_ISO_9660_INTERACTIVE:
	printf("CD-ROM with CD-RTOS and iso9660 fs\n");
	break;
    case FS_HIGH_SIERRA:
	printf("CD-ROM with high sierra fs\n");
	break;
    case FS_INTERACTIVE:
	printf("CD-Interactive%s\n", num_audio > 0 ? "/Ready" : "");
	break;
    case FS_HFS:
	printf("CD-ROM with Macintosh HFS\n");
	break;
    case FS_ISO_HFS:
	printf("CD-ROM with both Macintosh HFS and iso9660 fs\n");
	break;
    case FS_UFS:
	printf("CD-ROM with Unix UFS\n");
	break;
    case FS_EXT2:
	printf("CD-ROM with Linux second extended filesystem\n");
	break;
    case FS_3DO:
	printf("CD-ROM with Panasonic 3DO filesystem\n");
	break;
    case FS_UNKNOWN:
	printf("CD-ROM with unknown filesystem\n");
	break;
    }
    switch(fs & FS_MASK) {
    case FS_ISO_9660:
    case FS_ISO_9660_INTERACTIVE:
    case FS_ISO_HFS:
	printf("iso9660: %i MB size, label `%.32s'\n",
	       isofs_size/512,buffer+40);
	break;
    }
    need_lf = 0;
    if (first_data == 1 && num_audio > 0)
	need_lf += printf("mixed mode CD   ");
    if (fs & XA)
	need_lf += printf("XA sectors   ");
    if (fs & MULTISESSION)
	need_lf += printf("Multisession, offset = %i   ",ms_offset);
    if (fs & HIDDEN_TRACK)
	need_lf += printf("Hidden Track   ");
    if (fs & PHOTO_CD)
	need_lf += printf("%sPhoto CD   ", num_audio > 0 ? " Portfolio " : "");
    if (fs & CDTV)
	need_lf += printf("Commodore CDTV   ");
    if (first_data > 1)
	need_lf += printf("CD-Plus/Extra   ");
    if (fs & BOOTABLE)
	need_lf += printf("bootable CD   ");
    if (fs & VIDEOCDI && num_audio == 0)
	need_lf += printf("Video CD   ");
    if (need_lf) puts("");

   return(0);
}
*/
void frame2msf(unsigned long i, struct cdrom_msf *msf)
{
	msf->cdmsf_min0  =   i   /CD_SECS   /CD_FRAMES;
	msf->cdmsf_sec0  =  (i   /CD_FRAMES)%CD_SECS;
	msf->cdmsf_frame0=   i   %CD_FRAMES;
	msf->cdmsf_min1  =  (i+1)/CD_SECS   /CD_FRAMES;
	msf->cdmsf_sec1  = ((i+1)/CD_FRAMES)%CD_SECS;
	msf->cdmsf_frame1=  (i+1)%CD_FRAMES;
}
unsigned long msf2frame(struct cdrom_msf0 *msf)
{
	return(msf->minute*CD_SECS*CD_FRAMES+
			msf->second*CD_FRAMES+
			msf->frame);
}

int fisodump(char *dev,char *name)
{
typedef struct ISODR
{
	struct ISODR *next;
	char *path;
	struct iso_directory_record isodr;
} ISODR;
#define ISODR_EXTRA (sizeof(struct ISODR*)+sizeof(char*)+1)

enum {
	ISODR_FLAG_ISFILE=0,
	ISODR_FLAG_ISDIR=2
};

typedef struct
{
	struct ISODR *ISODR;
	struct ISODR *isodrtail;
	struct ISODR *isodr;
	struct cdrom_tochdr toc;
	struct cdrom_tocentry toce;
	struct cdrom_mcn mcn;
	struct cdrom_multisession ms;
	struct cdrom_msf msf;
	struct iso_directory_record *isodrptr;
	struct iso_primary_descriptor *isopd;
	unsigned long trackoffset, start, end;
	int session;
	int fd;
	u_char data[CD_FRAMESIZE_RAW], isopddata[CD_FRAMESIZE_RAW];
} ISO9660;
ISO9660 iso;
int i;
char track=0;
if((iso.fd=open(dev,O_RDONLY))==-1)return(-1);


	if(ioctl(iso.fd,CDROMREADTOCHDR,&iso.toc)==-1)return(-1);
	memset(&iso.toce,0,sizeof(iso.toce));
	iso.toce.cdte_format=CDROM_MSF;
	for(i=iso.toc.cdth_trk0; i<=iso.toc.cdth_trk1; i++)
	{
		iso.toce.cdte_track=i;
		if(ioctl(iso.fd,CDROMREADTOCENTRY,&iso.toce)==-1)
		{
			close(iso.fd);
			return(-1);
		}
		switch(iso.toce.cdte_format)
		{
			case CDROM_MSF:
				if(i==iso.toc.cdth_trk0+track)
					iso.trackoffset=msf2frame(&iso.toce.cdte_addr.msf);
				break;
			case CDROM_LBA:
				break;
		}
	}




	frame2msf(iso.trackoffset+16,&iso.msf);
	memcpy(iso.isopddata,&iso.msf,sizeof(iso.msf));
	if(ioctl(iso.fd,CDROMREADRAW,iso.isopddata,iso.isopddata) < 0)
	{
		close(iso.fd);
		return(-1);
	}
	iso.isopd=(struct iso_primary_descriptor*)(&iso.isopddata[CD_SYNC_SIZE+CD_HEAD_SIZE+CD_SUBHEAD_SIZE]);

fhexdump((char *)iso.isopd,0,sizeof(struct iso_primary_descriptor));

printf("\n%s\n\n",name);
//	printisopd(iso.isopd);

	printf("type: %d\n",*iso.isopd->type);
	printf("id: %5.5s\n",iso.isopd->id);
	printf("version: %d\n",*iso.isopd->version);
	printf("system_id: %32.32s\n",iso.isopd->system_id);
	printf("volume_id: %32.32s\n",iso.isopd->volume_id);
	printf("volume_space_size: %ld * %d\n",*(long*)iso.isopd->volume_space_size,ISOFS_BLOCK_SIZE);
	printf("volume_set_size: 0x%lx\n",*(long*)iso.isopd->volume_set_size);
	printf("volume_sequence_number: 0x%lx\n",*(long*)iso.isopd->volume_sequence_number);
	printf("logical_block_size: %ld\n",*(long*)iso.isopd->logical_block_size);
//	printf("path_table_size: %ld\n",*(long*)iso.isopd->path_table_size);
//	printf("type_l_path_table: %ld\n",*(long*)iso.isopd->type_l_path_table);
//	printf("opt_type_l_path_table: %ld\n",*(long*)iso.isopd->opt_type_l_path_table);
//	printf("type_m_path_table: %ld\n",*(long*)iso.isopd->type_m_path_table);
//	fhexdump(iso.isopd->type_m_path_table,0,4);
//	printf("\nopt_type_m_path_table: %ld\n",*(long*)iso.isopd->opt_type_m_path_table);
//	printf("iso directory record\n");
//	isodrptr=(struct iso_directory_record*)&iso.isopd->root_directory_record;
//	printisodr(isodrptr);
//	printf("root_directory_record: %.34s\n",iso.isopd->root_directory_record);
	printf("volume_set_id: %.28s\n",iso.isopd->volume_set_id);
	printf("publisher_id: %.128s\n",iso.isopd->publisher_id);
	printf("preparer_id: %.128s\n",iso.isopd->preparer_id);
	printf("application_id: %.128s\n",iso.isopd->application_id);
	printf("copyright_file_id: %.37s\n",iso.isopd->copyright_file_id);
	printf("abstract_file_id: %.37s\n",iso.isopd->abstract_file_id);
	printf("bibliographic_file_id: %.37s\n",iso.isopd->bibliographic_file_id);
	printf("file_structure_version: %d\n",*iso.isopd->file_structure_version);
//	printf("application_data: ");
//	fhexdump(iso.isopd->application_data,0,512);
	printf("\n");
				
        close(iso.fd);
//cdinfo(dev);
//	exit(0);
	return(0);
}

#define fcdromdump(x,y)	fisodump(x,y)

#define SIMI 1
#define DIFF 0
/*int fcmp(char *name,long start,char *name2,long start2,int mode)
{
	register long y,len;
	long x=0;
	int count=0;
	char buf[BUFSIZE],buf2[BUFSIZE];
	int stop=0;
	FILE *fh,*fh2;
	
	if(!strdcmp(name,name2))return(0);
        if(!(fh=fopen(name,"rb")))return(-1);
	if(!(fh2=fopen(name2,"rb")))
	{
		fclose(fh);
		return(-1);
	}

	x=0;
	for(;;)
	{
		if(!fread(buf,BUFSIZE,1,fh)||!fread(buf2,BUFSIZE,1,fh2))stop=1;
		y=0;
		while(y<BUFSIZE)
		{
			if(\
(mode==DIFF&&buf[y]!=buf2[y]) 	||\
(mode==SIMI&&buf[y]==buf2[y])	)
			{
				len=0;
				if(mode==DIFF)
				{
					count++;
					while(y+len<BUFSIZE&&buf[y+len]!=buf2[y+len])len++;
					printf("%s\n",name);
					fhexdump(buf,y,len);
					printf("\n");
				}
				else
				{
					while(y+len<BUFSIZE&&buf[y+len]==buf2[y+len])len++;
				}
				printf("%s\n",name2);
				fhexdump(buf2,y,len);
				printf("\n");
				y=y+len;
			}
			else {if(mode==SIMI)count++;}
			y++;
		}
		x++;
		if(stop!=0)break;
	}
	fclose(fh);
	fclose(fh2);
	return(count);
}
*/

int fcmp(char *fname,long fstart,char *fname2,long fstart2,int mode)
{
	register long x,y,len;
	char *buf,*buf2;
	FILE *fh,*fh2;
	
	if(!strdcmp(fname,fname2))return(0);


        if(!(fh=fopen(fname,"rb")))return(-1);
	if(!(fh2=fopen(fname2,"rb")))
	{
		fclose(fh);
		return(-1);
	}
	if(!(buf=(char *)malloc((fsize(fname,0)+2)*sizeof(char))))
	{
		fclose(fh);
		fclose(fh2);
        	return(-1);
	}
	if(!(buf2=(char *)malloc((fsize(fname2,0)+2)*sizeof(char))))
	{
		free(buf);
		fclose(fh);
		fclose(fh2);
		return(-1);
	}
	if(!fread(buf,fsize(fname,0),1,fh)||!fread(buf2,fsize(fname2,0),1,fh2))
	{
		free(buf);
		free(buf2);
		fclose(fh);
		fclose(fh2);
		return(-1);
	}	

	fclose(fh);
	fclose(fh2);
	x=((fsize(fname,0)-fstart)<(fsize(fname2,0)-fstart2))?(fsize(fname,0)-fstart):(fsize(fname2,0)-fstart2);

	for(y=0;y<x;y++)
	{
		if
		(
		(mode==DIFF&&buf[y+fstart]!=buf2[y+fstart2])
		||
		(mode==SIMI&&buf[y+fstart]==buf2[y+fstart2])	
		)
		{
			len=0;
			if(mode==DIFF)while(buf[y+fstart+len]!=buf2[y+fstart2+len])len++;
			else while(buf[y+fstart+len]==buf2[y+fstart2+len])len++;
			printf("%s\n",fname);
			fhexdump(buf,y+fstart,len);
			printf("%s\n",fname2);
			fhexdump(buf2,y+fstart2,len);
			printf("\n");
			y+=len;
		}
	}
	free(buf);
	free(buf2);
	return(0);
}

int freplace(char *fname,char wildcard,char *search,long slen,char *replace,long rlen,long fstart)
{
	register long x;
	x=fstart;
	
	for(;;)
	{
		x=fstrstr(fname,search,x,slen);
		if(x==-1)break;
		fhexdump(fname,x,slen);
		fstrncpy(fname,replace,x,rlen);		
		fhexdump(fname,x,rlen);
		printf("\n");
		x++;
	}
	return(0);
}


int fexpress(char *path)
{
struct UserMisc
{
  char Handle[31];
  ulong ConfAxx;
  char SentBy[45];
  ulong MiscInfo;
  char  Pad[255];
};
/*
struct ConfCfg
{
	int ConfNum;
	char ConfName[100];
	char ConfLoc[255];
	char MsgLoc[255];
	char Password[30];
	char SentBy;  //BOOL
	char MsgShared;//BOOL
};
 */
struct User {
 char    Name[31],Pass[9],Location[30],PhoneNumber[13];
u_short Slot_Number;
 u_short Sec_Status,
         Sec_Board,                   // File or Byte Ratio
         Sec_Library,                 // Ratio             
         Sec_Bulletin,                // Computer Type    
         Messages_Posted; // Note ConfYM = the last msg you actually read, ConfRead is the same ??
 ulong   NewSinceDate;
 ulong   ConfRead1, ConfRead2, ConfRead3, ConfRead4, ConfRead5,  ConfRead6,
         ConfRead7, ConfRead8, ConfRead9;
 char    Conference_Access[10];
 u_short Uploads, Downloads, ConfRJoin, Times_Called;
 long    Time_Last_On, Time_Used, Time_Limit, Time_Total;
 ulong   Bytes_Download,
	 Bytes_Upload,
	 Daily_Bytes_Limit,
	 Daily_Bytes_Dld;
 char    Expert;
 double  NBytes_Download,		// Bytes Downloaded as a "double"
	 NBytes_Upload,			// Bytes Uploaded as a "double"
	 NDaily_Bytes_Limit,		// Daily Bytes Limit
	 NDaily_Bytes_Dld;		// Bytes Downloaded today.
char   Flag1, Flag2, FLag3, EditorType;
long    BeginLogCall;
//char   Protocol, UUCPA, LineLength, New_User;
//bool8 !?!?!?

 };
/*
struct UserKeys {                
 char    UserName[31];
 long    Number;
 u_char   New_User;
u_short    UPcps,              // highest upload cps rate 
         DNcps,              // highest dnload cps rate 
         Userflags,          
         baud_rate;          // last online baud rate   
 u_char   QFlag,
         Who,
         MailScan,
         Language,
         QuietNode,
         MaxCalls,
         Called,
         ReplySkip;
 char    Pad[1];             // ?? should be 15      
};
*/
struct User user_data;
/*
struct UserKeys user_keys;
struct ConfCfg conf_cfg;
*/
struct UserMisc user_misc;

#define s16(x) __cpu_to_be16(x)
#define s32(x) __cpu_to_be32(x)
#define s64(x) __cpu_to_be64(x)
	register unsigned long x;
	long user;	
	int fd,fd2;
//	FILE *fh;
	
	user=fsize("user.data",0)/sizeof(struct User);

	if((fd=open("user.data",O_RDONLY))==-1)return(-1);
	if((fd2=open("user.misc",O_RDONLY))==-1)return(-1);
	
	for(x=0;x<user;x++)
	{
		
		read(fd,&user_data,sizeof(struct User));
                read(fd2,&user_misc,sizeof(struct UserMisc));
		                
		printf("%08ld %s",x,user_data.Name);
		printf(" | %s | %s | %s\n",user_data.Location,user_data.PhoneNumber,user_misc.SentBy);

//printf("\n");
	}

	close(fd);
	close(fd2);
return(0);
}



#include "defines.h"
